;;;;
;;;; pads-silks -- Various silk designs.
;;;;
;;;; Copyright 2007 Dean Ferreyra, All rights reserved
;;;;
;;;; This file is part of octw-guile-geda.
;;;;
;;;; octw-guile-geda is free software: you can redistribute it and/or modify
;;;; it under the terms of the GNU General Public License as published by
;;;; the Free Software Foundation, either version 3 of the License, or
;;;; (at your option) any later version.
;;;; 
;;;; octw-guile-geda is distributed in the hope that it will be useful,
;;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;; GNU General Public License for more details.
;;;; 
;;;; You should have received a copy of the GNU General Public License
;;;; along with octw-guile-geda.  If not, see <http://www.gnu.org/licenses/>.
;;;;
;;;; $Id: pads-silks.scm,v 1.2 2008-09-05 06:31:40 dean Exp $

(define-module (octw pads-silks))

(use-modules (oop goops))
(use-modules (srfi srfi-1)
	     (srfi srfi-13))
(use-modules (ice-9 optargs))
(use-modules (octw conditional)
             (octw anaphoric)
             (octw pads))
(use-syntax (ice-9 syncase))

(export phillips-screw
        slotted-screw)

(define (phillips-screw diameter angle thickness)
  (let ((circle (make-element-circle (/ diameter 2) thickness))
        (cross (make-element-line (* 0.3 diameter) thickness
                                  (angle->unit-vector angle))))
    (let ((crosses (combine cross (rotate cross 90))))
      (combine circle crosses))))

(define (slotted-screw diameter angle thickness)
  (let ((circle (make-element-circle (/ diameter 2) thickness))
        (slot (make-element-line diameter thickness
                                 (angle->unit-vector angle))))
    (combine circle slot)))
